#
# Makefile for Metaware HighC SNMP application for Waterloo TCP/IP
#

!include ..\common.mak

PROGS = snmpget.exp  snmpgetn.exp snmpbulk.exp snmpwalk.exp \
        snmpstat.exp snmptest.exp snmpset.exp  snmptrap.exp \
        snmptran.exp authkey.exp #snmpd.exp

LFLAGS= -libpath $(WATT_LIB);\dosx\lib                                   \
        -lib hc386, hc387, hcna, wattcphf, except, dosx32, ..\lib\snmp_x \
        -pack -offset 1000h -stack 307200 -386 -twocase -nostub          \
        -unprivileged -fullwarn -maxdata 0                               \
        -attributes class code  er                                       \
        -attributes class data  rw                                       \
        -attributes class stack rw                                       \
        -fullseg -symbols -publist both -purge none *                    \
        -mapnames 30 -mapwidth 132

all:  $(PROGS)

snmptrap.exp: snmptrap.c
       hc386 -c $(HC_CFLAGS) -I.. snmptrap.c
       386link snmptrap.obj -exe $*.exp @&&|
       $(LFLAGS)
|

snetstat.exp: inet.c if.c main.c route.c
       hc386 -c $(HC_CFLAGS) -I.. inet.c if.c main.c route.c
       386link inet.obj if.obj main.obj route.obj -exe $*.exp @&&|
       $(LFLAGS)
|

snmpd.exp: snmpd.c snmp_var.c snmp_age.c snmp_con.c
       hc386 -c $(HC_CFLAGS) -I.. snmpd.c snmp_var.c snmp_age.c
       386link -exe $*.exp @&&|
         inet.obj snmpd.obj snmp_var.obj snmp_age.obj snmp_con.obj
         $(LFLAGS)
|

.c.exp:
       hc386 -c $(HC_CFLAGS) -I.. $<
       386link $*.obj -exe $*.exp @&&|
       $(LFLAGS)
|

clean:
       @del *.map
       @del *.obj
       @del *.exp

