
#include <stdio.h>
#include <snmp.h>
#include <netinet/in.h>

/* in ..\snmp_src\usec.c */
void v2md5auth_password_to_key (char *password, u_long passwordlen,
                                u_char *agentID, u_char *key);

int main (int argc, char **argv)
{
  u_char key[16];
  u_char agentID[12];
  u_char *cp;
  int    i;

  if (argc != 3)
  {
    fprintf (stderr, "Usage: %s <password> <agentID>\n", argv[0]);
    return (1);
  }
  if (strlen(argv[2]) != 24)
  {
    fprintf (stderr, "bad agentID, must be 24 hex characters (12 octets)\n");
    return (1);
  }

  cp = (u_char*) argv[2];
  for (i = 0; i < 12; i++)
  {
    int x;
    sscanf (cp, "%2x", &x);
    agentID[i] = x & 0xff;
    cp += 2;
  }

  v2md5auth_password_to_key (argv[1], strlen(argv[1]), agentID, key);
  printf ("key for '%s' = ", argv[1]);
  for (i = 0; i < 16; i++)
    printf ("%02x", key[i]);

  printf ("\n");
  return (0);
}
