


AUTHKEY(1)                                             AUTHKEY(1)


NAME
       authkey  -  create  authKey for cmu snmpd and cmu managing
       applications

SYNOPSIS
       authKey <password> <agentID>

DESCRIPTION
       Authkey creates a 32 octet authKey from a password of your
       choice and 12 octet agent id. The result is printed in hex
       to stdout of the form:
       key for 'nase' = 05a1483bb7a0b314cc5cf9d27aee2a89


OPTIONS
       <password>
              The passwort string. this can be  any  string  like
              Joe or Sec88ret.

       <agentID>
              The  agentid should be a a string of 24 hex charac-
              ters without a leading 0x.


EXAMPLES
       authkey nase 000000230a0a0a0a00000000


About The Community Argument
       The agent and applications are all  SNMPv1/SNMPv2c/SNMPv2u
       compatible.   The version is that the application will use
       is selected by inspecting the first character of the  com-
       munity string provided to the application, as follows:

       o      if the first character of the community string is a
              "+" then the  SNMPv2c  (community-based  SNMPv2  as
              specified  in  RFC  1901) is used (the remainder of
              the community string is used as the  actual  commu-
              nity string);

       o      if the first character of the community string is a
              "/" then the SNMPv2u (User-based security model) is
              used (see the note below for more details);

       o      all other community strings select SNMPv1.


       A  community  string  that begins with a slash selects the
       SNMPv2u protocol.  The "community"  string  is  parsed  to
       build  the parameters for the communication. The format of
       the string is:
            /userName/[authKey]/[privKey]/[contextSelector]
       Trailing slashes may be omitted. Both authKey and  privKey
       may  be  specified as hex or as a human readable password.

       To specify a hex key, the key must begin with "0x" and  be
       followed  by  exactly  32  hex  digits (to form a 16 octet
       key).  If a human readable password is entered, the  pass-
       word  is passed through the "password to key algorithm" to
       generate the 16 octet key. The password to  key  algorithm
       is specified in the "User-Based Security Model for SNMPv2"
       RFC.

       A "+" or "/" character may not start  a  SNMPv1  community
       string  and may not be contained within any SNMPv2 parame-
       ters (this is an *implementation* restriction).

       Some "community" string examples:
       /joe                -- qos=noAuth/noPriv, context="", userName="joe"

       /boneless/chicken/ranch -- qos=auth/priv, context="", userName="boneless"
                         authKey=pw2key("chicken"), privKey=pw2key("ranch")
                         *note* privacy not supported, trying this will generate
                         a UnsupportedQoS report.

       /maplesyrup/sugarbush//other
                      -- qos=auth/noPriv, context="other", userName="maplesyrup"
                         authKey=pw2key("sugarbush",agentID)

       /glenn/0x4ca25023b00a6689ef21cb1b6fa9cb0e
                      -- qos=auth/noPriv, context="", userName="glenn"
                         authKey=4ca25023b00a6689ef21cb1b6fa9cb0e
                         (the authKey is keyed using an agentID)

       +public             -- SNMPv2c using public as the community string

       public              -- SNMPv1 using public as the community string


SEE ALSO
       snmpd.conf(5)
