#ifndef __SNMP_DEBUG_H
#define __SNMP_DEBUG_H

#define DEBUG_VARS        0
#define DEBUG_VARS_MALLOC 0

#define DEBUG_API         0
#define DEBUG_CLIENT      0
#define DEBUG_MIB_TTO     0
#define DEBUG_MSG_ENCODE  0
#define DEBUG_RYAN        0
#define DEBUG_PARSER      0

#define DEBUG_PDU         0
#define DEBUG_PDU_DECODE  0
#define DEBUG_PDU_ENCODE  0


#define DEBUG_PRINT0(pfx,str)             printf (pfx str)
#define DEBUG_PRINT1(pfx,fmt,a)           printf (pfx fmt,a)
#define DEBUG_PRINT2(pfx,fmt,a,b)         printf (pfx fmt,a,b)
#define DEBUG_PRINT3(pfx,fmt,a,b,c)       printf (pfx fmt,a,b,c)
#define DEBUG_PRINT4(pfx,fmt,a,b,c,d)     printf (pfx fmt,a,b,c,d)
#define DEBUG_PRINT5(pfx,fmt,a,b,c,d,e)   printf (pfx fmt,a,b,c,d,e)

#if DEBUG_API
  #define API_DEBUG0(str)                 DEBUG_PRINT0 ("LIBSNMP: ",str)
  #define API_DEBUG1(fmt,a)               DEBUG_PRINT1 ("LIBSNMP: ",fmt,a)
  #define API_DEBUG2(fmt,a,b)             DEBUG_PRINT2 ("LIBSNMP: ",fmt,a,b)
  #define API_DEBUG3(fmt,a,b,c)           DEBUG_PRINT3 ("LIBSNMP: ",fmt,a,b,c)
  #define API_DEBUG4(fmt,a,b,c,d)         DEBUG_PRINT4 ("LIBSNMP: ",fmt,a,b,c,d)
#else
  #define API_DEBUG0(str)                 ((void)0)
  #define API_DEBUG1(fmt,a)               ((void)0)
  #define API_DEBUG2(fmt,a,b)             ((void)0)
  #define API_DEBUG3(fmt,a,b,c)           ((void)0)
  #define API_DEBUG4(fmt,a,b,c,d)         ((void)0)
#endif

#if DEBUG_MIB_TTO
  #define MIBTT_DEBUG0(str)               DEBUG_PRINT0 ("",str)
  #define MIBTT_DEBUG1(fmt,a)             DEBUG_PRINT1 ("",fmt,a)
  #define MIBTT_DEBUG2(fmt,a,b)           DEBUG_PRINT2 ("",fmt,a,b)
  #define MIBTT_DEBUG3(fmt,a,b,c)         DEBUG_PRINT3 ("",fmt,a,b,c)
  #define MIBTT_DEBUG4(fmt,a,b,c,d)       DEBUG_PRINT4 ("",fmt,a,b,c,d)
#else
  #define MIBTT_DEBUG0(str)               ((void)0)
  #define MIBTT_DEBUG1(fmt,a)             ((void)0)
  #define MIBTT_DEBUG2(fmt,a,b)           ((void)0)
  #define MIBTT_DEBUG3(fmt,a,b,c)         ((void)0)
  #define MIBTT_DEBUG4(fmt,a,b,c,d)       ((void)0)
#endif

#if DEBUG_MSG_ENCODE
  #define MSG_ENCODE_DEBUG0(str)          DEBUG_PRINT0 ("MSG: ",str)
  #define MSG_ENCODE_DEBUG1(fmt,a)        DEBUG_PRINT1 ("MSG: ",fmt,a)
  #define MSG_ENCODE_DEBUG2(fmt,a,b)      DEBUG_PRINT2 ("MSG: ",fmt,a,b)
  #define MSG_ENCODE_DEBUG3(fmt,a,b,c)    DEBUG_PRINT3 ("MSG: ",fmt,a,b,c)
  #define MSG_ENCODE_DEBUG4(fmt,a,b,c,d)  DEBUG_PRINT4 ("MSG: ",fmt,a,b,c,d)
#else
  #define MSG_ENCODE_DEBUG0(str)          ((void)0)
  #define MSG_ENCODE_DEBUG1(fmt,a)        ((void)0)
  #define MSG_ENCODE_DEBUG2(fmt,a,b)      ((void)0)
  #define MSG_ENCODE_DEBUG3(fmt,a,b,c)    ((void)0)
  #define MSG_ENCODE_DEBUG4(fmt,a,b,c,d)  ((void)0)
#endif

#if DEBUG_RYAN
  #define RYAN_DEBUG0(str)                DEBUG_PRINT0 ("TOKEN: ",str)
  #define RYAN_DEBUG1(fmt,a)              DEBUG_PRINT1 ("TOKEN: ",fmt,a)
  #define RYAN_DEBUG2(fmt,a,b)            DEBUG_PRINT2 ("TOKEN: ",fmt,a,b)
  #define RYAN_DEBUG3(fmt,a,b,c)          DEBUG_PRINT3 ("TOKEN: ",fmt,a,b,c)
  #define RYAN_DEBUG4(fmt,a,b,c,d)        DEBUG_PRINT4 ("TOKEN: ",fmt,a,b,c,d)
#else
  #define RYAN_DEBUG0(str)                ((void)0)
  #define RYAN_DEBUG1(fmt,a)              ((void)0)
  #define RYAN_DEBUG2(fmt,a,b)            ((void)0)
  #define RYAN_DEBUG3(fmt,a,b,c)          ((void)0)
  #define RYAN_DEBUG4(fmt,a,b,c,d)        ((void)0)
#endif

#if DEBUG_PARSER
  #define PARSER_DEBUG0(str)              DEBUG_PRINT0 ("PARSER: ",str)
  #define PARSER_DEBUG1(fmt,a)            DEBUG_PRINT1 ("PARSER: ",fmt,a)
  #define PARSER_DEBUG2(fmt,a,b)          DEBUG_PRINT2 ("PARSER: ",fmt,a,b)
  #define PARSER_DEBUG3(fmt,a,b,c)        DEBUG_PRINT3 ("PARSER: ",fmt,a,b,c)
  #define PARSER_DEBUG4(fmt,a,b,c,d)      DEBUG_PRINT4 ("PARSER: ",fmt,a,b,c,d)
#else
  #define PARSER_DEBUG0(str)              ((void)0)
  #define PARSER_DEBUG1(fmt,a)            ((void)0)
  #define PARSER_DEBUG2(fmt,a,b)          ((void)0)
  #define PARSER_DEBUG3(fmt,a,b,c)        ((void)0)
  #define PARSER_DEBUG4(fmt,a,b,c,d)      ((void)0)
#endif

#if DEBUG_PDU
  #define PDU_DEBUG0(str)                 DEBUG_PRINT0 ("PDU: ",str)
  #define PDU_DEBUG1(fmt,a)               DEBUG_PRINT1 ("PDU: ",fmt,a)
  #define PDU_DEBUG2(fmt,a,b)             DEBUG_PRINT2 ("PDU: ",fmt,a,b)
  #define PDU_DEBUG3(fmt,a,b,c)           DEBUG_PRINT3 ("PDU: ",fmt,a,b,c)
  #define PDU_DEBUG4(fmt,a,b,c,d)         DEBUG_PRINT4 ("PDU: ",fmt,a,b,c,d)
#else
  #define PDU_DEBUG0(str)                 ((void)0)
  #define PDU_DEBUG1(fmt,a)               ((void)0)
  #define PDU_DEBUG2(fmt,a,b)             ((void)0)
  #define PDU_DEBUG3(fmt,a,b,c)           ((void)0)
  #define PDU_DEBUG4(fmt,a,b,c,d)         ((void)0)
#endif

#if DEBUG_PDU_DECODE
  #define PDU_DECODE_DEBUG0(str)          DEBUG_PRINT0 ("PDU: ",str)
  #define PDU_DECODE_DEBUG1(fmt,a)        DEBUG_PRINT1 ("PDU: ",fmt,a)
  #define PDU_DECODE_DEBUG2(fmt,a,b)      DEBUG_PRINT2 ("PDU: ",fmt,a,b)
  #define PDU_DECODE_DEBUG3(fmt,a,b,c)    DEBUG_PRINT3 ("PDU: ",fmt,a,b,c)
  #define PDU_DECODE_DEBUG4(fmt,a,b,c,d)  DEBUG_PRINT4 ("PDU: ",fmt,a,b,c,d)
#else
  #define PDU_DECODE_DEBUG0(str)          ((void)0)
  #define PDU_DECODE_DEBUG1(fmt,a)        ((void)0)
  #define PDU_DECODE_DEBUG2(fmt,a,b)      ((void)0)
  #define PDU_DECODE_DEBUG3(fmt,a,b,c)    ((void)0)
  #define PDU_DECODE_DEBUG4(fmt,a,b,c,d)  ((void)0)
#endif

#if DEBUG_PDU_ENCODE
  #define PDU_ENCODE_DEBUG0(str)          DEBUG_PRINT0 ("PDU: ",str)
  #define PDU_ENCODE_DEBUG1(fmt,a)        DEBUG_PRINT1 ("PDU: ",fmt,a)
  #define PDU_ENCODE_DEBUG2(fmt,a,b)      DEBUG_PRINT2 ("PDU: ",fmt,a,b)
  #define PDU_ENCODE_DEBUG3(fmt,a,b,c)    DEBUG_PRINT3 ("PDU: ",fmt,a,b,c)
  #define PDU_ENCODE_DEBUG4(fmt,a,b,c,d)  DEBUG_PRINT4 ("PDU: ",fmt,a,b,c,d)
#else
  #define PDU_ENCODE_DEBUG0(str)          ((void)0)
  #define PDU_ENCODE_DEBUG1(fmt,a)        ((void)0)
  #define PDU_ENCODE_DEBUG2(fmt,a,b)      ((void)0)
  #define PDU_ENCODE_DEBUG3(fmt,a,b,c)    ((void)0)
  #define PDU_ENCODE_DEBUG4(fmt,a,b,c,d)  ((void)0)
#endif

#if DEBUG_VARS
  #define VARS_DEBUG0(str)                DEBUG_PRINT0 ("VARS: ",str)
  #define VARS_DEBUG1(fmt,a)              DEBUG_PRINT1 ("VARS: ",fmt,a)
  #define VARS_DEBUG2(fmt,a,b)            DEBUG_PRINT2 ("VARS: ",fmt,a,b)
  #define VARS_DEBUG3(fmt,a,b,c)          DEBUG_PRINT3 ("VARS: ",fmt,a,b,c)
  #define VARS_DEBUG4(fmt,a,b,c,d)        DEBUG_PRINT4 ("VARS: ",fmt,a,b,c,d)
  #define VARS_DEBUG5(fmt,a,b,c,d,e)      DEBUG_PRINT5 ("VARS: ",fmt,a,b,c,d,e)
#else
  #define VARS_DEBUG0(str)                ((void)0)
  #define VARS_DEBUG1(fmt,a)              ((void)0)
  #define VARS_DEBUG2(fmt,a,b)            ((void)0)
  #define VARS_DEBUG3(fmt,a,b,c)          ((void)0)
  #define VARS_DEBUG4(fmt,a,b,c,d)        ((void)0)
  #define VARS_DEBUG5(fmt,a,b,c,d,e)      ((void)0)
#endif

#endif
