#ifndef __SNMP_LIB_H
#define __SNMP_LIB_H

/**********************************************************************
 *
 *           Copyright 1998 by Carnegie Mellon University
 * 
 *                       All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of CMU not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 * 
 * CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 * 
 **********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <malloc.h>
#include <time.h>
#include <ctype.h>
#include <limits.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <netdb.h>
#include <tcp.h>

#include "asn1.h"
#include "error.h"
#include "extra.h"
#include "impl.h"
#include "parse.h"
#include "dump.h"
#include "debug.h"

#include "vars.h"
#include "pdu.h"
#include "msg.h"
#include "session.h"
#include "coexist.h"
#include "version.h"
#include "md5.h"
#include "usec.h"

#include "api.h"
#include "api_util.h"
#include "api_err.h"
#include "client.h"
#include "mclient.h"
#include "internal.h"
#include "mib.h"
#include "mibii.h"
#include "compat.h"

#ifdef USE_FORTIFY
#include "fortify.h"
#endif

extern struct session_list *Sessions;

#endif
